<template>
  <div class="ui-header-mobile-menu uikit-flex justify-start uikit-items-center">
    <ui-link
      class="toggle"
      @click="toggle"
    >
      <UiIconBurger
        :width="18"
        :height="18"
      />
    </ui-link>

    <teleport
      to="#ui-mobile-header-menu-place"
      v-if="isOpen"
    >
      <nav class="ui-mobile-header-menu-content">
        <ul class="uikit-flex uikit-flex-col uikit-space-y-32">
          <li
            class="uikit-h-full"
            :key="index"
            v-for="(link, index) in links"
          >
            <ui-link
              class="uikit-text-14 uikit-flex uikit-flex-col uikit-justify-center uikit-items-center uikit-leading-none uikit-h-full"
              v-bind="link"
            />
          </li>
          <li class="uikit-h-full">
            <ui-link
              class="uikit-text-14 uikit-flex uikit-flex-col uikit-justify-center uikit-items-center uikit-leading-none uikit-h-full"
              href="https://docs.slr.finance"
              rel="noopener noreferrer"
            >
              <div>Knowledge base</div>
            </ui-link>
          </li>
        </ul>
      </nav>
    </teleport>
  </div>
</template>

<script lang="ts">
  import type { UiLinkProps } from '../UiLink'
  import { defineComponent, PropType, watch } from 'vue'
  import { useRoute } from 'vue-router'
  import { useToggle } from '@vueuse/shared'
  import { UiIconBurger } from '../UiIcon'
  import { UiLink } from '../UiLink'

  export default defineComponent({
    name: 'ui-mobile-header-menu',
    props: {
      links: {
        type: Array as PropType<UiLinkProps[]>,
        required: true,
      },
    },
    setup() {
      const [isOpen, toggle] = useToggle()
      const route = useRoute()

      watch(route, () => {
        isOpen.value = false
      })

      return {
        isOpen,
        toggle: () => toggle(),
      }
    },
    components: {
      UiLink,
      UiIconBurger,
    },
  })
</script>

<style>
  .ui-header-mobile-menu > .toggle {
    position: relative;
    z-index: 1001;
  }
  .ui-mobile-header-menu-content {
    padding-top: calc(var(--app-ui-header-height) + var(--app-ui-header-offset));

    @apply uikit-fixed uikit-top-0 uikit-left-0 uikit-z-mobile-menu uikit-w-full uikit-h-full uikit-bg-black;
  }
</style>
